Subject: Re: [PATCH v2] pull: introduce --merge option

From: Junio C Hamano <[email-masked]>
Date: Wed, 28 Jul 2021 10:18:10 -0700

Matthias Baumgarten <[email-masked]> writes:

> Add to Felipes list:
>
>  * git switch -m
>
> and maybe git cherry-pick -m where -m does not mean "merge" itself but
> is used to determine the parent of the merge (when picking merge 
> commits) to base on.
>
> Other examples of where -m has different meaning than merge:
>
>  * git am -m (message-id)
>  * git branch -m (move branch)
>
> I would rephrase the question as to what would I expect `git pull -m`
> to do, if I had never heard of it before. In the case of
> fast-forwarding and rebasing trying to add a merge commit message with
> -m would not even make sense. Only in the case of trying to create a
> merge commit by issuing git pull this would make sense. So if we could
> agree on that being not the most used scenario, I think -m would be a
> great short option for --merge.

I am afraid that you are misinterpreting what I said, comparing
apples and oranges, and drawing a wrong conclusion.

When I said "-m" would not fly well as a short-hand for "--merge" in
the context of "pull", I didn't mean "nobody would think 'm' stands
for 'merge'", and I didn't mean "more people would think 'm' stands
for 'message' more than 'merge'".  The reason why I find it
problematic is because it can be ambiguous.

When we step back and think about your "switch -m" and its synonym
"checkout -m", we realize that these commands fundamentally never
take "--message", as there is no place to record such a message
(they do not create a commit after all), after they switch to a
different branch while carrying the local modification forward by
performing a (possibly conflicting) content-level merge.  That is
why we can give their "merge" operation a short-and-sweet "m"
without confusing our users.  So contrasting "switch" having "-m"
that means "merge" with "pull" that can conceivably take both
"merge" and "message" is not a comparison you can draw useful
conclusion from.